module Order2cb
  class Caseblocks

    def initialize(logger)
      @logger = logger
    end

    def completed_orders(start_time = Time.now.utc - 4200, end_time = Time.now.utc)
      results = $client.query("SELECT number, state, payment_state, card_type, pp_payment_id, completed_at, title, first_name, surname, email, total FROM exp_spree_orders WHERE completed_at > '#{start_time.strftime("%Y-%m-%d %H-%M-%S")}' and completed_at < '#{end_time.strftime("%Y-%m-%d %H-%M-%S")}'")
      results
    rescue => e
      @logger.error e.message
      @logger.error e.backtrace.join('\n')
      false
    end

    def order_exists?(order)
      response = RestClient.get "#{ENV['CB_API_ENDPOINT']}/case_blocks/search.json?auth_token=#{ENV['CB_API_TOKEN']}&case_type_id=#{ENV['CB_TS_TYPE_ID']}&query=order_number:#{order.number}"
      response.code==200 && JSON.parse(response.body).count > 0
    rescue => e
      @logger.error e.message
      @logger.error e.backtrace.join('\n')
      raise e
    end

    def create_order(order)
      response = RestClient.post "#{ENV['CB_API_ENDPOINT']}/case_blocks/cases?auth_token=#{ENV['CB_API_TOKEN']}", order.to_json, :content_type => :json, :accept => :json
      response.code==201 && JSON.parse(response.body).count > 0
    rescue => e
      @logger.error e.message
      @logger.error e.backtrace.join('\n')
      false
    end

  end
end
